VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "ft Mobile Robots II : Hinderniserkennung"
   ClientHeight    =   5295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7545
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "MobRob2Hin.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5295
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox cboPortName 
      Height          =   315
      ItemData        =   "MobRob2Hin.frx":030A
      Left            =   5880
      List            =   "MobRob2Hin.frx":031D
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   3720
      Width           =   1335
   End
   Begin VB.CommandButton cmdEnde 
      Caption         =   "&ENDE"
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   4200
      Width           =   1335
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "&START"
      Height          =   375
      Left            =   5880
      TabIndex        =   0
      Top             =   4680
      Width           =   1335
   End
   Begin VB.Image Image1 
      Height          =   735
      Left            =   6000
      Picture         =   "MobRob2Hin.frx":033E
      Stretch         =   -1  'True
      Top             =   2880
      Width           =   1125
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Zentriert
      BackColor       =   &H80000009&
      Caption         =   "START/ENDE"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   360
      TabIndex        =   2
      Top             =   480
      Width           =   6735
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ----------------------------------------------------------------------------------------
'
' frmMain(MobRob2Hin.frm)                                           Ulrich Mller 28.11.02
'                                                                   PCS1700          VB6.0
' ft Mobile Robots II : Hinderniserkennung
' auf Basis von FishFa30.DLL und umFish30.DLL, um-Variante
' nach Mobile Robots II : Hindernis.MDL
'
'
' -----------------------------------------------------------------------------------------

Option Explicit


Dim ft As New FishFace


Private Sub Action()

' --- Routine fr den Modellbetrieb ---

  Do
    If Not (ft.GetInput(ftiE3) Or ft.GetInput(ftiE4)) Then
    ' --- Geradeausfahren -----------------
      ft.SetMotor ftiM1, ftiLinks
      ft.SetMotor ftiM2, ftiLinks
    Else
      ' --- Sobald Hindernis an E3 oder E4 : Anhalten -------
      ft.SetMotor ftiM1, ftiAus
      ft.SetMotor ftiM2, ftiAus
      ft.Pause 200
    
      If ft.GetInput(ftiE3) And ft.GetInput(ftiE4) Then
      ' --- Hindernis vorne ----
        Zurueck 4
        Links 8
      ElseIf ft.GetInput(ftiE3) Then
      ' --- Hindernis rechts -----
        Zurueck 3
        Links 4
      ElseIf ft.GetInput(ftiE4) Then
      ' --- Hindernis links -------
        Zurueck 3
        Rechts 2
      End If
    End If
  Loop Until ft.Finish()
  
End Sub

Private Sub Links(Pos&)
' --- Pos Impulse nach Links ----
Dim Z1&
  
  ft.SetMotor ftiM1, ftiLinks
  ft.SetMotor ftiM2, ftiRechts
  
  Z1 = 0
  ft.WaitForPositionUp ftiE1, Z1, Pos
  
  ft.SetMotor ftiM1, ftiAus
  ft.SetMotor ftiM2, ftiAus
  
End Sub

Private Sub Rechts(Pos&)
' --- Pos Impulse nach Rechts ---
Dim Z1&
  
  ft.SetMotor ftiM1, ftiRechts
  ft.SetMotor ftiM2, ftiLinks
  
  Z1 = 0
  ft.WaitForPositionUp ftiE1, Z1, Pos
  
  ft.SetMotor ftiM1, ftiAus
  ft.SetMotor ftiM2, ftiAus

End Sub


Private Sub Zurueck(Pos&)
' --- Pos Impulse zurck, bei Hindernis hinten, wieder 2 Impulse vor ---
Dim Z1&
  
  ft.SetMotor ftiM1, ftiRechts
  ft.SetMotor ftiM2, ftiRechts
  
  Z1 = 0
  ft.WaitForPositionUp ftiE1, Z1, Pos, ftiE5
  
  ft.SetMotor ftiM1, ftiAus
  ft.SetMotor ftiM2, ftiAus

  If Z1 < Pos Then
  ' --- Wenn Hindernis hinten (ftiE5), wieder vorwrts ---
    ft.SetMotor ftiM1, ftiLinks
    ft.SetMotor ftiM2, ftiLinks
    
    Z1 = 0
    ft.WaitForPositionUp ftiE1, Z1, 2
    
    ft.SetMotor ftiM1, ftiAus
    ft.SetMotor ftiM2, ftiAus
  End If
  
End Sub

Private Sub cmdAction_Click()
  
' --- Steuern des Modellbetriebs ------------------------------

On Error GoTo ftiFehler

  ' --- mit Port aus Liste, AnalogScan, ohne Slave, default PollInterval ---
  ft.OpenInterface cboPortName.Text, True
  
  
  cmdAction.Enabled = False
  cmdEnde.Caption = "&HALT"
  lblStatus.Caption = "Luft"
    
    Action
  
  ft.ClearMotors
  ft.CloseInterface
  
  cmdAction.Enabled = True
  cmdEnde.Caption = "&ENDE"
  lblStatus.Caption = "START/ENDE"
  cmdEnde.SetFocus
  Exit Sub
  
ftiFehler:
  lblStatus = Err.Number & " : " & Err.Source & "." & Err.Description
  ft.CloseInterface
  cmdEnde.Caption = "&ENDE"
End Sub


Private Sub cmdEnde_Click()

' --- Beenden des Modellbetrieb, wenn HALT-Button, sonst Programmende ---

  If cmdEnde.Caption = "&HALT" Then ft.NotHalt = True Else Unload Me
  
End Sub


Private Sub Form_Load()

  cboPortName.ListIndex = 2
  
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

' --- Sperren des Form-Abbruch-Buttons (x links oben) whrend des
'     Modellbetriebes (HALT-Button)

  If cmdEnde.Caption = "&HALT" Then Cancel = 1
  
End Sub

